/*
 * Copyright (c) 2016-2017 Digital Bazaar, Inc. All rights reserved.
 */
'use strict';

var crypto = require('crypto');

module.exports = MessageDigest;

/**
 * Creates a new MessageDigest.
 *
 * @param algorithm the algorithm to use.
 */
function MessageDigest(algorithm) {
  if(!(this instanceof MessageDigest)) {
    return new MessageDigest(algorithm);
  }

  this.md = crypto.createHash(algorithm);
}

MessageDigest.prototype.update = function(msg) {
  this.md.update(msg, 'utf8');
};

MessageDigest.prototype.digest = function() {
  return this.md.digest('hex');
};
